<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------


namespace app\adminapi\controller\property;


use app\adminapi\controller\BaseAdminController;
use app\adminapi\lists\property\PropertyOrderAnalysis;
use app\adminapi\lists\property\PropertyOrderLists;
use app\adminapi\logic\property\PropertyOrderLogic;
use app\adminapi\validate\property\PropertyOrderValidate;
use app\api\validate\ServiceOrderValidate;


/**
 * PropertyOrder控制器
 * Class PropertyOrderController
 * @package app\adminapi\controller
 */
class PropertyOrderController extends BaseAdminController
{
    public array $notNeedLogin = ['placeOrder'];


    /**
     * @notes 获取列表
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/09/19 14:48
     */
    public function lists()
    {
        return $this->dataLists(new PropertyOrderLists());
    }


    /**
     * @notes 添加
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/09/19 14:48
     */
    public function add()
    {
        /*$params = (new PropertyOrderValidate())->post()->goCheck('add');
        $result = PropertyOrderLogic::add($params);
        if (true === $result) {
            return $this->success('添加成功', [], 1, 1);
        }
        return $this->fail(PropertyOrderLogic::getError());*/
        return $this->fail('无后台添加');
    }


    /**
     * @notes 编辑
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/09/19 14:48
     */
    public function edit()
    {
        $params = (new PropertyOrderValidate())->post()->goCheck('edit');
        $result = PropertyOrderLogic::edit($params);
        if (true === $result) {
            return $this->success('编辑成功', [], 1, 1);
        }
        return $this->fail(PropertyOrderLogic::getError());
    }


    /**
     * @notes 删除
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/09/19 14:48
     */
    public function delete()
    {
        $params = (new PropertyOrderValidate())->post()->goCheck('delete');
        PropertyOrderLogic::delete($params);
        return $this->success('删除成功', [], 1, 1);
    }


    /**
     * @notes 获取详情
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/09/19 14:48
     */
    public function detail()
    {
        $params = (new PropertyOrderValidate())->goCheck('detail');
        $result = PropertyOrderLogic::detail($params);
        return $this->data($result);
    }

    /**
     * @notes 客服下工单
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/09/19 14:48
     */
    public function placeOrder()
    {
        $serviceOrderParams = (new ServiceOrderValidate())->post()->goCheck('add');
        if (empty($serviceOrderParams['id'])){
            return $this->fail('物业单id不能为空');
        }
        $result = PropertyOrderLogic::placeOrder($serviceOrderParams);
        if (true === $result) {
            return $this->success('客服下单成功', [], 1, 1);
        }
        return $this->fail(PropertyOrderLogic::getError());
    }
    /**
     * @notes 客服取消订单
     * @return \think\response\Json
     */
    public function cancel()
    {
        $params = (new PropertyOrderValidate())->post()->goCheck('detail');
        $result = PropertyOrderLogic::cancel($params);
        if (true === $result) {
            return $this->success('取消成功', [], 1, 1);
        }
        return $this->fail(PropertyOrderLogic::getError());
    }
    /**
     * @notes 物业订单数据分析
     * @return \think\response\Json
     */
    public function propertyOrderAnalysis()
    {
        return $this->dataLists(new PropertyOrderAnalysis());
    }

}